package libvorbis.modes;

import libvorbis.Jadj_stereo;
import libvorbis.Jatt3;
import libvorbis.Jnoise3;
import libvorbis.Jnoiseguard;
import libvorbis.Jvp_adjblock;

/** 16kHz settings */

public final class Jpsych_16 {
	/** stereo mode by base quality level */
	protected static final Jadj_stereo _psy_stereo_modes_16[] = {// [4]
		/*  0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  */
		new Jadj_stereo(
		new int[]{  4,  4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3},
		new int[]{  6,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4},
		new float[]{  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  4,  4},
		new float[]{ 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99}),
		new Jadj_stereo(
		new int[]{  4,  4,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3},
		new int[]{  6,  5,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4},
		new float[]{  2,  2,  2,  2,  2,  2,  2,  2,  2,  3,  4,  4,  4,  4,  4},
		new float[]{ 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99}),
		new Jadj_stereo(
		new int[]{  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3},
		new int[]{  5,  4,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3},
		new float[]{  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4},
		new float[]{ 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99}),
		new Jadj_stereo(
		new int[]{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0},
		new int[]{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0},
		new float[]{  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8},
		new float[]{ 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99}),
	};

	protected static final double _psy_lowpass_16[] = {6.5,8,30.,99.};// [4]

	protected static final Jatt3 _psy_tone_masteratt_16[] = {// [4]
		new Jatt3(new int[]{ 30,  25,  12},  0,   0),  /* 0 */
		new Jatt3(new int[]{ 25,  22,  12},  0,   0),  /* 0 */
		new Jatt3(new int[]{ 20,  12,   0},  0,   0),  /* 0 */
		new Jatt3(new int[]{ 15,   0, -14},  0,   0), /* 0 */
	};

	protected static final Jvp_adjblock _vp_tonemask_adj_16[] = {// [4]
		/* adjust for mode zero */
		/* 63     125     250     500       1     2     4     8    16 */
		new Jvp_adjblock(new int[]{-20,-20,-20,-20,-20,-16,-10,  0,  0, 0, 0,10, 0, 0, 0, 0, 0}), /* 0 */
		new Jvp_adjblock(new int[]{-20,-20,-20,-20,-20,-16,-10,  0,  0, 0, 0,10, 0, 0, 0, 0, 0}), /* 1 */
		new Jvp_adjblock(new int[]{-20,-20,-20,-20,-20,-16,-10,  0,  0, 0, 0, 0, 0, 0, 0, 0, 0}), /* 2 */
		new Jvp_adjblock(new int[]{-30,-30,-30,-30,-30,-26,-20,-10, -5, 0, 0, 0, 0, 0, 0, 0, 0}), /* 2 */
	};

	protected static final Jnoise3 _psy_noisebias_16_short[] = {// [4]
		/*  63     125     250     500      1k       2k      4k      8k     16k*/
		new Jnoise3(
		new int[][]{{-15,-15,-15,-15,-15,-10,-10,-5,   4, 10, 10, 10, 10, 12, 12, 14, 20},
		{-15,-15,-15,-15,-15,-10,-10, -5,  0,  0,  4,  5,  5,  6,  8,  8, 15},
		{-30,-30,-30,-30,-30,-24,-20,-14,-10, -6, -8, -8, -6, -6, -6, -6, -6}}),

		new Jnoise3(
		new int[][]{{-15,-15,-15,-15,-15,-10,-10,-5,   4,  6,  6,  6,  6,  8, 10, 12, 20},
		{-15,-15,-15,-15,-15,-15,-15,-10, -5, -5, -5,  4,  5,  6,  8,  8, 15},
		{-30,-30,-30,-30,-30,-24,-20,-14,-10,-10,-10,-10,-10,-10,-10,-10,-10}}),

		new Jnoise3(
		new int[][]{{-15,-15,-15,-15,-15,-12,-10, -8,  0,  2,  4,  4,  5,  5,  5,  8, 12},
		{-20,-20,-20,-20,-16,-12,-20,-14,-10,-10, -8,  0,  0,  0,  0,  2,  5},
		{-30,-30,-30,-30,-26,-26,-26,-26,-26,-26,-26,-26,-26,-24,-20,-20,-20}}),

		new Jnoise3(
		new int[][]{{-15,-15,-15,-15,-15,-12,-10, -8, -5, -5, -5, -5, -5,  0,  0,  0,  6},
		{-30,-30,-30,-30,-26,-22,-20,-14,-12,-12,-10,-10,-10,-10,-10,-10, -6},
		{-30,-30,-30,-30,-26,-26,-26,-26,-26,-26,-26,-26,-26,-24,-20,-20,-20}}),
	};

	protected static final Jnoise3 _psy_noisebias_16_impulse[] = {// [4]
		/*  63     125     250     500      1k       2k      4k      8k     16k*/
		new Jnoise3(
		new int[][]{{-15,-15,-15,-15,-15,-10,-10,-5,   4, 10, 10, 10, 10, 12, 12, 14, 20},
		{-15,-15,-15,-15,-15,-10,-10, -5,  0,  0,  4,  5,  5,  6,  8,  8, 15},
		{-30,-30,-30,-30,-30,-24,-20,-14,-10, -6, -8, -8, -6, -6, -6, -6, -6}}),

		new Jnoise3(
		new int[][]{{-15,-15,-15,-15,-15,-10,-10,-5,   4,  4,  4,  4,  5,  5,  6,  8, 15},
		{-15,-15,-15,-15,-15,-15,-15,-10, -5, -5, -5,  0,  0,  0,  0,  4, 10},
		{-30,-30,-30,-30,-30,-24,-20,-14,-10,-10,-10,-10,-10,-10,-10,-10,-10}}),

		new Jnoise3(
		new int[][]{{-15,-15,-15,-15,-15,-12,-10, -8,  0,  0,  0,  0,  0,  0,  0,  4, 10},
		{-20,-20,-20,-20,-16,-12,-20,-14,-10,-10,-10,-10,-10,-10,-10, -7, -5},
		{-30,-30,-30,-30,-26,-26,-26,-26,-26,-26,-26,-26,-26,-24,-20,-20,-20}}),

		new Jnoise3(
		new int[][]{{-15,-15,-15,-15,-15,-12,-10, -8, -5, -5, -5, -5, -5,  0,  0,  0,  6},
		{-30,-30,-30,-30,-26,-22,-20,-18,-18,-18,-20,-20,-20,-20,-20,-20,-16},
		{-30,-30,-30,-30,-26,-26,-26,-26,-26,-26,-26,-26,-26,-24,-20,-20,-20}}),
	};

	protected static final Jnoise3 _psy_noisebias_16[] = {// [4]
		/*  63     125     250     500      1k       2k      4k      8k     16k*/
		new Jnoise3(
		new int[][]{{-10,-10,-10,-10, -5, -5, -5,  0,  4,  6,  8,  8, 10, 10, 10, 14, 20},
		{-10,-10,-10,-10,-10, -5, -2, -2,  0,  0,  0,  4,  5,  6,  8,  8, 15},
		{-30,-30,-30,-30,-30,-24,-20,-14,-10, -6, -8, -8, -6, -6, -6, -6, -6}}),

		new Jnoise3(
		new int[][]{{-10,-10,-10,-10, -5, -5, -5,  0,  4,  6,  6,  6,  6,  8, 10, 12, 20},
		{-15,-15,-15,-15,-15,-10, -5, -5,  0,  0,  0,  4,  5,  6,  8,  8, 15},
		{-30,-30,-30,-30,-30,-24,-20,-14,-10, -6, -8, -8, -6, -6, -6, -6, -6}}),

		new Jnoise3(
		new int[][]{{-15,-15,-15,-15,-15,-12,-10, -8,  0,  2,  4,  4,  5,  5,  5,  8, 12},
		{-20,-20,-20,-20,-16,-12,-20,-10, -5, -5,  0,  0,  0,  0,  0,  2,  5},
		{-30,-30,-30,-30,-26,-26,-26,-26,-26,-26,-26,-26,-26,-24,-20,-20,-20}}),

		new Jnoise3(
		new int[][]{{-15,-15,-15,-15,-15,-12,-10, -8, -5, -5, -5, -5, -5,  0,  0,  0,  6},
		{-30,-30,-30,-30,-26,-22,-20,-14,-12,-12,-10,-10,-10,-10,-10,-10, -6},
		{-30,-30,-30,-30,-26,-26,-26,-26,-26,-26,-26,-26,-26,-24,-20,-20,-20}}),
	};

	protected static final Jnoiseguard _psy_noiseguards_16[] = {// [4]
		new Jnoiseguard(10,10,-1),
		new Jnoiseguard(10,10,-1),
		new Jnoiseguard(20,20,-1),
		new Jnoiseguard(20,20,-1),
	};

	protected static final double _noise_thresh_16[] = { .3,.5,.5,.5 };// [4]

	protected static final int _noise_start_16[] = { 256,256,9999 };// [3]

	protected static final int _noise_part_16[] = { 8,8,8,8 };// [4]

	protected static final int _psy_ath_floater_16[] = {// [4]
		-100,-100,-100,-105,
	};

	protected static final int _psy_ath_abs_16[] = {// [4]
		-130,-130,-130,-140,
	};
}
